package ch.zhaw.gartenverwaltung.io;

import ch.zhaw.gartenverwaltung.types.HardinessZone;
import ch.zhaw.gartenverwaltung.types.Plant;
import com.fasterxml.jackson.databind.ObjectMapper;

import java.io.IOException;
import java.net.URL;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Collections;
import java.util.List;
import java.util.Optional;

public class JsonPlantDatabase implements PlantDatabase {
    private final URL dataSource = getClass().getResource("plantdb.json");

    @Override
    public List<Plant> getPlantList(HardinessZone zone) throws IOException {
        List<Plant> result = Collections.emptyList();

        if (dataSource != null) {
            ObjectMapper mapper = new ObjectMapper();
            DateFormat dateFormat = new SimpleDateFormat("MM-dd");
            mapper.setDateFormat(dateFormat);

            result = mapper.readerForListOf(Plant.class).readValue(dataSource);
        }

        return result;
    }

    @Override
    public Optional<Plant> getPlantById(long id) {
        return Optional.empty();
    }
}
